#include <stdio.h>
#define InFile          "homeless.in"
#define OutFile         "homeless.out"

#define MaxStatii       1010
#define MaxTren         1010
#define StatLinie       1010
#define DURATA          620

int graf[MaxStatii+1][MaxStatii+1];
/* graf[i][j]=durata deplasarii intre statia i si j, daca exista
   tronson de la i la j si 0 altfel */
int mat[DURATA][MaxStatii];
/* mat[i][j]= timpul minim de asteptare necesar pentru a ajunge in statia j la momentul i*/
typedef struct
{
        int N;
        int plec;
        int unde;  /*unde se afla trenul acesta la momentul plec */
        int st[StatLinie];
} Tren;

int tt[2*DURATA+100];
Tren v[MaxTren];

int main ( void )
{FILE *in, *out;
 int N, P, V;
 int i, st;
 int S1, S2, durata;
 int T1, T2;
 int timp;
 int grad, *unde;
 int min=100000000;

 in=fopen (InFile, "r");
 fscanf (in, "%d %d %d %d %d", &N, &P, &V, &T1, &T2);
 for (i=0; i<P; i++)
     {fscanf (in, "%d %d %d", &S1, &S2, &durata);
      graf[S1][S2]=graf[S2][S1]=durata;      }
 for (i=0; i<V; i++)
     {fscanf (in, "%d%d", &v[i].plec, &v[i].N);
      v[i].unde=0;
      for (st=0; st<v[i].N; st++)
          fscanf (in, "%d", v[i].st+st);
      }
 fclose(in);

 for (i=0; i<2*DURATA+100; i++)
     tt[i]=i%DURATA;
 for (i=0; i<DURATA; i++)
      for (grad=1; grad<=N; grad++)
          mat[i][grad]=-1;
 mat[0][1]=0;

 for (timp=1, unde=tt; timp<=T2; timp++)
     {
     if (timp>=T1)
        if (mat[*unde][1]<min)
           min=mat[*unde][1];
     for (grad=1; grad<=N; grad++)
         {
         if (mat[*unde][grad]>=0)
            if (mat[unde[1]][grad]==-1 ||
               mat[*unde][grad]+1<mat[unde[1]][grad])
         mat[unde[1]][grad]=mat[*unde][grad]+1;
         }

      for (i=0; i<V; i++)
          if (v[i].plec==timp)
            { /* trenul i pleaca la momentul timp */
              S1=v[i].st[v[i].unde]; /* statia din care pleaca */
              S2=v[i].st[v[i].unde+1];/* statia in care ajunge */
              durata=graf[S1][S2];
              if (++v[i].unde < v[i].N-1)
                 v[i].plec+=durata;    /* trenul i va ajunge in statia unde la momentul plec */
                 else
                 v[i].plec=100000000;   /* trenul i a ajuns la destinatie */

              if (mat[*unde][S1]==-1) continue;
              if (mat[unde[durata]][S2]==-1 ||
                  mat[*unde][S1]<mat[unde[durata]][S2])
                  mat[unde[durata]][S2]=mat[*unde][S1];
              }

                for (grad=1; grad<=N; grad++)
                        mat[*unde][grad]=-1;
                if (++unde-tt==DURATA)
                        unde=tt;
        }

out=fopen (OutFile, "w");
fprintf (out, "%d\n", min);
fclose (out);
return 0;
}
